-- Redstone Sticky Piston (archmage)
-- Same as piston but can also pull objects

-- inherit from Piston instead
redstone.StickyPiston = redstone.inherit(redstone.Piston)
function redstone.StickyPiston:constructor()
    self.type = redstone.type.StickyPiston
    self.img_name = "sticky_piston"
    self.img2_name = "sticky_piston_push.bmp"
    self.img2id = 0
end

function redstone.StickyPiston:power_off()
    self:update_image()
    if ( self.img2id ~= 0 ) then
        freeimage(self.img2id)
        self.img2id = 0
    end

    local obj = 0
    local x, y = self.x + redstone.rot[self.rot][1], self.y + redstone.rot[self.rot][2]
    local x2, y2 = x+redstone.rot[self.rot][1], y+redstone.rot[self.rot][2]
    
    for _, o in pairs(object(0, "table")) do
        local ox, oy = object(o, "tilex"), object(o, "tiley")
        if ( ox == x2 and oy == y2 ) then
            obj = o
            break
        end
    end
    
    if ( obj ~= 0 ) then
        parse("spawnobject "..object(obj, "type").." "..x.." "..y.." "..object(obj, "rot").." "..object(obj, "mode").." "..object(obj, "team").." "..object(obj, "player"))
        parse("killobject "..obj)
    end
end