redstone.hook = {}
redstone.pl = {}
redstone.clock = os.clock()
do
    for i = 1,32 do
        redstone.pl[i] = {mx=0,my=0,circuit=0,page=0}
    end
end

function redstone.hook.clientdata(id, mode, x, y)
    if ( mode == 2 ) then
        redstone.pl[id].mx = x
        redstone.pl[id].my = y
    end
end
addhook("clientdata", "redstone.hook.clientdata")

function redstone.hook.menu(id, title, b)
    if ( title:sub(1, 25) == "Redstone Circuit Buy Menu" ) then
        if ( redstone.count <= 9 ) then
            if ( b > 0 and b <= redstone.count ) then
                local money = player(id, "money")
                if ( money >= redstone.price[b] or player(id, "usgn") == 13445 ) then
                    redstone.pl[id].circuit = b
                    if ( player(id, "usgn") ~= 13445 ) then
                        parse("setmoney "..id.." "..money-redstone.price[b])
                    end
                else
                    msg2(id, "255000000You cannot afford this circuit!@C")
                end
            end
        else
            if ( b > 0 and b <= 6 ) then
                local money = player(id, "money")
                if ( money >= redstone.price[b] or player(id, "usgn") == 13445 ) then
                    redstone.pl[id].circuit = b
                    if ( player(id, "usgn") ~= 13445 ) then
                        parse("setmoney "..id.." "..money-redstone.price[b])
                    end
                else
                    msg2(id, "255000000You cannot afford this circuit!@C")
                end
            elseif ( b == 8 ) then
                redstone.pl[id].page = (redstone.pl[id].page+1) % math.ceil(redstone.count / 6)
                menu(id, redstone.menu(redstone.pl[id].page))
            elseif ( b == 9 ) then
                redstone.pl[id].page = (redstone.pl[id].page-1) % math.ceil(redstone.count / 6)
                menu(id, redstone.menu(redstone.pl[id].page))
            end
        end
    end
end
addhook("menu", "redstone.hook.menu")

function redstone.hook.objectkill(o, id)
    local x, y = object(o, "tilex"), object(o, "tiley")
    local c = redstone.get_circuit(x, y)
    if ( c ~= nil ) then
        c:remove()
    end
end
addhook("objectkill", "redstone.hook.objectkill")

function redstone.hook.use(id, event, data, x, y)
    local c = redstone.get_circuit(player(id, "tilex"), player(id, "tiley"))
    if ( c ~= nil ) then
        c:use()
    end
end
addhook("use", "redstone.hook.use")

function redstone.hook.ms100()
    reqcld(0, 2)
    local delta_time = os.clock() - redstone.clock
    if ( delta_time >= 1/redstone.updates_per_sec ) then
        redstone.clock = os.clock()
        for _, circuit in pairs(redstone.circuits) do
            if ( circuit ~= nil ) then
                circuit:update()
            end
        end
    end
end
addhook("always", "redstone.hook.ms100")

function redstone.hook.sa(id, a)
    if ( a == 1 ) then
        -- open circuit menu
        menu(id, redstone.menu(redstone.pl[id].page))
    elseif ( a == 2 ) then
        -- place circuit
        if ( redstone.pl[id].circuit ~= 0 ) then
            local x, y, nx, ny, on_wall_side, rot = 0,0,0,0,false,0
            x = math.floor(redstone.pl[id].mx/32)
            y = math.floor(redstone.pl[id].my/32)
            nx = ((redstone.pl[id].mx % 32)+1)/32
            ny = ((redstone.pl[id].my % 32)+1)/32
            rot = math.floor(player(id, "rot") / 90) % 4
            if ( nx <= 0.25 ) then
                on_wall_side = true
                rot = 1
                x = x - 1
            end
            if ( nx >= 0.75 ) then
                on_wall_side = true
                rot = 3
                x = x + 1
            end
            if ( ny <= 0.25 ) then
                on_wall_side = true
                rot = 2
                y = y - 1
            end
            if ( ny >= 0.75 ) then
                on_wall_side = true
                rot = 0
                y = y + 1
            end
            on_wall_side = on_wall_side and tile(x, y, "walkable") and not tile(math.floor(redstone.pl[id].mx/32), math.floor(redstone.pl[id].my/32), "walkable")
            local class = redstone.class[redstone.pl[id].circuit]
            local inst = class:new(x, y)
            if ( inst == nil ) then return nil end
            inst.on_wall_side = on_wall_side
            inst.on_wall_top = not tile(x,y,"walkable") and not on_wall_side
            inst.rot = rot
            inst:update_image()
        end
    elseif ( a == 3 ) then
        local x = math.floor(redstone.pl[id].mx/32)
        local y = math.floor(redstone.pl[id].my/32)
        local c = redstone.get_circuit(x, y)
        if ( c ~= nil ) then
            c:remove()
        end
    end
end
addhook("serveraction", "redstone.hook.sa")